'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e["default"] : e; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

const errorBoundary = (Element, errorCallback) => {
  return class ErrorBoundary extends React.Component {
    constructor(props) {
      super(props);
      this.state = { hasError: false };
    }
    componentDidCatch(error) {
      this.setState({ hasError: true });
      errorCallback(error);
    }
    render() {
      if (this.state.hasError) {
        return null;
      }
      return React__default.isValidElement(Element) ? Element : null;
    }
  };
};
var errorBoundary$1 = errorBoundary;

exports["default"] = errorBoundary$1;
//# sourceMappingURL=errorBoundary.js.map
