'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var kira = require('@kira-ui/core');
var errorBoundary = require('./errorBoundary.js');
var transform = require('./transform.js');
var evalCode = require('./evalCode.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e["default"] : e; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    for (var k in e) {
      n[k] = e[k];
    }
  }
  n["default"] = e;
  return Object.freeze(n);
}

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var kira__namespace = /*#__PURE__*/_interopNamespace(kira);

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
const renderElementAsync = ({ code = "", scope = __spreadValues({}, kira__namespace) }, resultCallback, errorCallback) => {
  const render = (element) => {
    if (typeof element === "undefined")
      errorCallback(new SyntaxError("`render` must be called with valid JSX."));
    else
      resultCallback(errorBoundary["default"](element, errorCallback));
  };
  if (!/render\s*\(/.test(code)) {
    return errorCallback(new SyntaxError("evaluations must call `render`."));
  }
  evalCode["default"](transform["default"](code.replaceAll(/import\s+\{[^}]+\}\s+from\s+['"]([^'"]+)['"];*/g, "")), __spreadProps(__spreadValues({ React: React__default }, scope), { render }));
};

exports.renderElementAsync = renderElementAsync;
//# sourceMappingURL=index.js.map
