import React, { Component } from 'react';

const errorBoundary = (Element, errorCallback) => {
  return class ErrorBoundary extends Component {
    constructor(props) {
      super(props);
      this.state = { hasError: false };
    }
    componentDidCatch(error) {
      this.setState({ hasError: true });
      errorCallback(error);
    }
    render() {
      if (this.state.hasError) {
        return null;
      }
      return React.isValidElement(Element) ? Element : null;
    }
  };
};
var errorBoundary$1 = errorBoundary;

export { errorBoundary$1 as default };
//# sourceMappingURL=errorBoundary.js.map
