import React from 'react';
import * as kira from '@kira-ui/core';
import errorBoundary from './errorBoundary.js';
import transform from './transform.js';
import evalCode from './evalCode.js';

var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
const renderElementAsync = ({ code = "", scope = __spreadValues({}, kira) }, resultCallback, errorCallback) => {
  const render = (element) => {
    if (typeof element === "undefined")
      errorCallback(new SyntaxError("`render` must be called with valid JSX."));
    else
      resultCallback(errorBoundary(element, errorCallback));
  };
  if (!/render\s*\(/.test(code)) {
    return errorCallback(new SyntaxError("evaluations must call `render`."));
  }
  evalCode(transform(code.replaceAll(/import\s+\{[^}]+\}\s+from\s+['"]([^'"]+)['"];*/g, "")), __spreadProps(__spreadValues({ React }, scope), { render }));
};

export { renderElementAsync };
//# sourceMappingURL=index.js.map
